#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include "../../plugin.hpp"
#include "memory.h"
#include "bcplugin.h"

PluginStartupInfo Info;
FARSTANDARDFUNCTIONS FSF;
char PluginRootKey[80];
BOOL IsOldFAR=TRUE;

Options Opt={2,FALSE,TRUE,TRUE,FALSE,TRUE,FALSE,TRUE,FALSE};
PlugOptions PlgOpt={1,SHOW_IN_VIEWER|SHOW_IN_EDITOR|SHOW_IN_CONFIG,0,1,TRUE,TRUE,TRUE,TRUE,FALSE,FALSE,FALSE,0};

static BOOL CheckPipeEx(void);

#include "bcopy_eject.cpp"
#include "bcplugdialogproc.cpp"
#include "bcconfig.cpp"

void WINAPI _export SetStartupInfo(const struct PluginStartupInfo *Info)
{
  memset(&::Info,0,sizeof(::Info));
  memmove(&::Info,Info,(Info->StructSize>(int)sizeof(::Info))?sizeof(::Info):Info->StructSize);
  if(Info->StructSize>FAR165_INFO_SIZE)
  {
    IsOldFAR=FALSE;
    ::FSF=*Info->FSF;
    ::Info.FSF=&::FSF;

    strcpy(PluginRootKey,Info->RootKey);
    strcat(PluginRootKey,"\\BCopy");

    HKEY hKey;
    DWORD Type;
    DWORD DataSize=0;
    if ((RegOpenKeyEx(HKEY_CURRENT_USER,PluginRootKey,0,
           KEY_QUERY_VALUE,&hKey))==ERROR_SUCCESS)
    {
      //tech options
      DataSize=sizeof(PlgOpt.AutoStart);
      RegQueryValueEx(hKey,"TechAutoStart",0,&Type,(LPBYTE)&PlgOpt.AutoStart,&DataSize);
      DataSize=sizeof(PlgOpt.ShowMenu);
      RegQueryValueEx(hKey,"TechShowMenu",0,&Type,(LPBYTE)&PlgOpt.ShowMenu,&DataSize);
      DataSize=sizeof(PlgOpt.InfoMenu);
      RegQueryValueEx(hKey,"TechInfoMenu",0,&Type,(LPBYTE)&PlgOpt.InfoMenu,&DataSize);
      DataSize=sizeof(PlgOpt.ExpandVars);
      RegQueryValueEx(hKey,"TechExpandVars",0,&Type,(LPBYTE)&PlgOpt.ExpandVars,&DataSize);
      DataSize=sizeof(PlgOpt.CheckPassive);
      RegQueryValueEx(hKey,"TechCheckPassive",0,&Type,(LPBYTE)&PlgOpt.CheckPassive,&DataSize);
      DataSize=sizeof(PlgOpt.FormatSize);
      RegQueryValueEx(hKey,"TechFormatSize",0,&Type,(LPBYTE)&PlgOpt.FormatSize,&DataSize);
      DataSize=sizeof(PlgOpt.AutoShowInfo);
      RegQueryValueEx(hKey,"TechAutoShowInfo",0,&Type,(LPBYTE)&PlgOpt.AutoShowInfo,&DataSize);
      DataSize=sizeof(PlgOpt.ConfirmAbort);
      RegQueryValueEx(hKey,"TechConfirmAbort",0,&Type,(LPBYTE)&PlgOpt.ConfirmAbort,&DataSize);
      DataSize=sizeof(PlgOpt.CurrentTime);
      RegQueryValueEx(hKey,"TechCurrentTime",0,&Type,(LPBYTE)&PlgOpt.CurrentTime,&DataSize);
      DataSize=sizeof(PlgOpt.ErrorColor);
      RegQueryValueEx(hKey,"TechErrorColor",0,&Type,(LPBYTE)&PlgOpt.ErrorColor,&DataSize);
      DataSize=sizeof(PlgOpt.AutoRefresh);
      RegQueryValueEx(hKey,"TechAutoRefresh",0,&Type,(LPBYTE)&PlgOpt.AutoRefresh,&DataSize);
      DataSize=sizeof(PlgOpt.ForceEject);
      RegQueryValueEx(hKey,"TechForceEject",0,&Type,(LPBYTE)&PlgOpt.ForceEject,&DataSize);
      //copy options
      DataSize=sizeof(Opt.CopyType);
      RegQueryValueEx(hKey,"CopyType",0,&Type,(LPBYTE)&Opt.CopyType,&DataSize);
      DataSize=sizeof(Opt.CopyHistory);
      RegQueryValueEx(hKey,"CopyHistory",0,&Type,(LPBYTE)&Opt.CopyHistory,&DataSize);
      DataSize=sizeof(Opt.CopyROSrc);
      RegQueryValueEx(hKey,"CopyROSrc",0,&Type,(LPBYTE)&Opt.CopyROSrc,&DataSize);
      DataSize=sizeof(Opt.CopyRODest);
      RegQueryValueEx(hKey,"CopyRODest",0,&Type,(LPBYTE)&Opt.CopyRODest,&DataSize);
      DataSize=sizeof(Opt.CopyAbort);
      RegQueryValueEx(hKey,"CopyAbort",0,&Type,(LPBYTE)&Opt.CopyAbort,&DataSize);
      DataSize=sizeof(Opt.CopyFullInfo);
      RegQueryValueEx(hKey,"CopyFullInfo",0,&Type,(LPBYTE)&Opt.CopyFullInfo,&DataSize);
      DataSize=sizeof(Opt.CopyAccess);
      RegQueryValueEx(hKey,"CopyAccess",0,&Type,(LPBYTE)&Opt.CopyAccess,&DataSize);
      //delete options
      DataSize=sizeof(Opt.DeleteRO);
      RegQueryValueEx(hKey,"DeleteRO",0,&Type,(LPBYTE)&Opt.DeleteRO,&DataSize);
      DataSize=sizeof(Opt.DeleteAbort);
      RegQueryValueEx(hKey,"DeleteAbort",0,&Type,(LPBYTE)&Opt.DeleteAbort,&DataSize);
      RegCloseKey(hKey);
    }
    if((Opt.CopyType>3)||(Opt.CopyType<0))
      Opt.CopyType=2;
  }
}

void WINAPI _export GetPluginInfo(struct PluginInfo *Info)
{
  if(!IsOldFAR)
  {
    Info->StructSize=sizeof(*Info);
    Info->Flags=0;
    if(PlgOpt.ShowMenu&SHOW_IN_VIEWER)
      Info->Flags|=PF_VIEWER;
    if(PlgOpt.ShowMenu&SHOW_IN_EDITOR)
      Info->Flags|=PF_EDITOR;
    Info->DiskMenuStringsNumber=0;
    static const char *PluginMenuStrings[1];
    PluginMenuStrings[0]=GetMsg(mName);
    Info->PluginMenuStrings=PluginMenuStrings;
    Info->PluginMenuStringsNumber=sizeof(PluginMenuStrings)/sizeof(PluginMenuStrings[0]);
    Info->PluginConfigStrings=PluginMenuStrings;
    Info->PluginConfigStringsNumber=0;
    if(PlgOpt.ShowMenu&SHOW_IN_CONFIG)
      Info->PluginConfigStringsNumber=sizeof(PluginMenuStrings)/sizeof(PluginMenuStrings[0]);
  }
}

int WINAPI _export GetMinFarVersion(void)
{
  return FARMANAGERVERSION;
}

static void SendToPipe(DWORD *send,DWORD sendsize,SmallInfoRec *RetData)
{
  HANDLE hPipe=CreateFile(PIPE_NAME,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
  if(hPipe!=INVALID_HANDLE_VALUE)
  {
    DWORD transfered;
    if(WriteFile(hPipe,send,sendsize,&transfered,NULL))
      ReadFile(hPipe,RetData,sizeof(SmallInfoRec),&transfered,NULL);
    CloseHandle(hPipe);
  }
}

static BOOL CheckPipe(void)
{
  HANDLE hPipe=CreateFile(PIPE_NAME,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
  if(hPipe!=INVALID_HANDLE_VALUE)
  {
    CloseHandle(hPipe);
    return TRUE;
  }
  return FALSE;
}

static BOOL CheckPipeEx(void)
{
  BOOL Result=CheckPipe();
  if(!Result)
  {
    if(PlgOpt.AutoStart)
    {
      SC_HANDLE ServiceControlHandle;
      SC_HANDLE SCManagerHandle;
      SERVICE_STATUS ServiceStatus;

      SCManagerHandle=OpenSCManager(NULL,NULL,SC_MANAGER_ALL_ACCESS);
      if(SCManagerHandle>0)
      {
        ServiceControlHandle=OpenService(SCManagerHandle,SVC_NAME,SERVICE_ALL_ACCESS);
        if(ServiceControlHandle>0)
        {
          if(StartService(ServiceControlHandle,0,NULL))
          {
            while(QueryServiceStatus(ServiceControlHandle,&ServiceStatus))
            {
              if(ServiceStatus.dwCurrentState==SERVICE_START_PENDING)
                Sleep(200);
              else
                break;
            }
            if(ServiceStatus.dwCurrentState==SERVICE_RUNNING)
              Result=CheckPipe();
          }
          CloseServiceHandle(ServiceControlHandle);
        }
        CloseServiceHandle(SCManagerHandle);
      }
    }
  }
  return Result;
}

static bool GetClearReadOnly(void)
{
  return (Info.AdvControl(Info.ModuleNumber,ACTL_GETSYSTEMSETTINGS,NULL)&FSS_CLEARROATTRIBUTE);
}

static int NumberType(int num)
{
  int Result=0,mod;
  mod=num%100;
  if((mod>20)||(mod<5))
  {
    mod=num%10;
    if((mod<5)&&(mod>0)) Result--;
    if(mod==1) Result--;
  }
  return Result;
}

static void NormalizeName(int width,int msg,char *filename,char *dest)
{
  int msg_len=strlen(GetMsg(msg))-2;
  char truncated[MAX_PATH];
  strcpy(truncated,filename);
  FSF.TruncPathStr(truncated,width-msg_len);
  sprintf(dest,GetMsg(msg),truncated);
}

static const char *GetRealName(const WIN32_FIND_DATAA *src)
{
  WIN32_FIND_DATAA find,find_ok; HANDLE hFind; BOOL Res;
  hFind=FindFirstFileA(src->cFileName,&find);
  if(hFind!=INVALID_HANDLE_VALUE)
  {
    memcpy(&find_ok,&find,sizeof(find));
    Res=FindNextFileA(hFind,&find);
    FindClose(hFind);
    if((!Res)&&(!_stricmp(src->cAlternateFileName,find_ok.cAlternateFileName)))
    {
      return src->cFileName;
    }
  }
  if(src->cAlternateFileName[0])
  {
    hFind=FindFirstFileA(src->cAlternateFileName,&find);
    if(hFind!=INVALID_HANDLE_VALUE)
    {
      FindClose(hFind);
      return src->cAlternateFileName;
    }
  }
  return NULL;
}

static BOOL CheckPaths(wchar_t *Src,wchar_t *Dest,BOOL Trim)
{
  if(Trim)
    return !_wcsnicmp(Src,Dest,wcslen(Src));
  else
    return !_wcsicmp(Src,Dest);
}

static bool CheckSystemFile(char *name)
{
  if(name[strlen(name)-1]=='\\') return false;
  HANDLE handle=CreateFileA(name,0,FILE_SHARE_DELETE|FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,0,NULL);
  if(handle!=INVALID_HANDLE_VALUE)
  {
    CloseHandle(handle);
    char path[MAX_PATH];
    strcpy(path,name);
    strcat(path,"\\");
    if(GetDriveType(path)<2) return true;
  }
  return false;
}

HANDLE WINAPI _export OpenPlugin(int OpenFrom,int Item)
{
  int MenuCode=-1;
  FarMenuItem MenuItems[mMenuInfo-mMenuCopy+1];
  unsigned int MenuItemsSize=mMenuInfo-mMenuCopy+1;
  memset(MenuItems,0,sizeof(MenuItems));
  int Msgs[]={mMenuCopy,mMenuMove,mMenuDelete,mMenuAttr,mMenuWipe,mMenuSep1,mMenuView,mMenuEdit,mMenuSep2,mMenuEject,mMenuReject,mMenuRefreshSCSI,mMenuSep3,mMenuConfig,mMenuInfo};
  if(OpenFrom!=OPEN_PLUGINSMENU)
  {
    MenuItemsSize=mMenuInfo-mMenuSep2;
    memcpy(Msgs,Msgs+mMenuEject-mMenuCopy,sizeof(Msgs[0])*MenuItemsSize);
  }
  for(unsigned int i=0;i<MenuItemsSize;i++)
  {
    MenuItems[i].Selected=MenuItems[i].Checked=MenuItems[i].Separator=0;
    strcpy(MenuItems[i].Text,GetMsg(Msgs[i]));
    if(MenuItems[i].Text[0]=='-') MenuItems[i].Separator=TRUE;
  };

  // First item is selected
  MenuItems[0].Selected=TRUE;
  // Show menu
  MenuCode=Info.Menu(Info.ModuleNumber,-1,-1,0,FMENU_WRAPMODE,
                         GetMsg(mName),NULL,"Contents",NULL,NULL,
                         MenuItems,MenuItemsSize);
  if((OpenFrom!=OPEN_PLUGINSMENU)&&(MenuCode>=0))
    MenuCode+=mMenuEject-mMenuCopy;
  //prepare source dir
  PanelInfo PInfo;
  Info.Control(INVALID_HANDLE_VALUE,FCTL_GETPANELINFO,&PInfo);

  if((MenuCode<8)&&(MenuCode>=0))
  {
    if((PInfo.SelectedItemsNumber>0)&&(!PInfo.Plugin))
    {
      bool bcopy_flags[BCOPY_FLAG_COUNT];
      for(int i=0;i<BCOPY_FLAG_COUNT;i++) bcopy_flags[i]=false;
      char SrcA[MAX_PATH]; wchar_t SrcW[MAX_PATH];
      strcpy(SrcA,PInfo.CurDir);
      UNCPath(SrcA);
      FSF.AddEndSlash(SrcA);
      MultiByteToWideChar(CP_OEMCP,0,SrcA,-1,SrcW,MAX_PATH);

      DWORD *send=NULL;
      DWORD sendsize=sizeof(DWORD)*3+sizeof(FileRec)*(PInfo.SelectedItemsNumber+2);
      if(MenuCode<5)
        send=(DWORD *)malloc(sendsize);
      SmallInfoRec RetData;
      switch(MenuCode)
      {
        case 0:
        case 1:
        {
          if(!send) break;
          if(!CheckPipeEx()) break;
          PanelInfo PAnotherInfo;
          Info.Control(INVALID_HANDLE_VALUE,FCTL_GETANOTHERPANELINFO,&PAnotherInfo);
          if(PlgOpt.CheckPassive&&PAnotherInfo.Plugin)
            break;

          char DestA[MAX_PATH]; wchar_t DestW[MAX_PATH];
          if(PAnotherInfo.Plugin)
            strcpy(DestA,"");
          else
          {
            strcpy(DestA,PAnotherInfo.CurDir);
            UNCPath(DestA);
            FSF.AddEndSlash(DestA);
          }

          //Show dialog
          /*
            0000000000111111111122222222223333333333444444444455555555556666666666777777
            0123456789012345678901234567890123456789012345678901234567890123456789012345
          00                                                                            00
          01    Copy ͻ   01
          02    Copy "bcopy.cpp" to                                                   02
          03    \WINNT\Profiles\Administrator\Personal\!Far_plugs\bc\doc\reversi\ |   03
          04   Ķ   04
          05    ( ) Overwrite all existing files                                      05
          06    ( ) Append to all existing files                                      06
          07    ( ) Skip all existing files                                           07
          08    ( ) Refresh old files                                                 08
          09                                                                          09
          10    [ ] Remove source files                                               10
          11    [ ] Copy access rights                                                11
          12    [ ] Clear R/O attribute on &source                                    12
          13    [ ] Clear R/O attribute on &destination                               13
          14    [ ] Abort on error                                                    14
          15   Ķ   15
          16                    [ Copy ]                [ Cancel ]                    16
          17   ͼ   17
          18                                                                            18
            0000000000111111111122222222223333333333444444444455555555556666666666777777
            0123456789012345678901234567890123456789012345678901234567890123456789012345
          */
          char *CopyHistoryName="Copy";
          char *BCopyCopyHistoryName="BCopyCopy";
          static struct InitDialogItem InitDlg[]={
          /* 0*/  {DI_DOUBLEBOX,3,1,72,17,0,0,0,0,(char *)mCpyDlgCopyTitle},
          /* 1*/  {DI_TEXT,5,2,0,0,0,0,DIF_SHOWAMPERSAND,0,""},
          /* 2*/  {DI_EDIT,5,3,70,0,1,(DWORD)BCopyCopyHistoryName,DIF_HISTORY,0,""},
          /* 3*/  {DI_TEXT,5,4,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0,""},
          /* 4*/  {DI_RADIOBUTTON,5,5,0,0,0,0,DIF_GROUP,0,(char *)mCpyDlgOpt1},
          /* 5*/  {DI_RADIOBUTTON,5,6,0,0,0,0,0,0,(char *)mCpyDlgOpt2},
          /* 6*/  {DI_RADIOBUTTON,5,7,0,0,0,0,0,0,(char *)mCpyDlgOpt3},
          /* 7*/  {DI_RADIOBUTTON,5,8,0,0,0,0,0,0,(char *)mCpyDlgOpt4},
          /* 8*/  {DI_CHECKBOX,5,10,0,0,0,0,0,0,(char *)mCpyDlgChk1},
          /* 9*/  {DI_CHECKBOX,5,11,0,0,0,0,0,0,(char *)mCpyDlgChkAccess},
          /*10*/  {DI_CHECKBOX,5,12,0,0,0,0,DIF_DISABLE,0,(char *)mCpyDlgChk2},
          /*11*/  {DI_CHECKBOX,5,13,0,0,0,0,DIF_DISABLE,0,(char *)mCpyDlgChk3},
          /*12*/  {DI_CHECKBOX,5,14,0,0,0,0,0,0,(char *)mCpyDlgChk4},
          /*13*/  {DI_TEXT,5,15,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0,""},
          /*14*/  {DI_BUTTON,0,16,0,0,0,0,DIF_CENTERGROUP,1,(char *)mCpyDlgOkCopy},
          /*15*/  {DI_BUTTON,0,16,0,0,0,0,DIF_CENTERGROUP,0,(char *)mCpyDlgCancel},
          };

          struct FarDialogItem DialogItems[sizeof(InitDlg)/sizeof(InitDlg[0])];
          InitDialogItems(InitDlg,DialogItems,sizeof(InitDlg)/sizeof(InitDlg[0]));
          if(Opt.CopyHistory)
            DialogItems[2].History=CopyHistoryName;
          DialogItems[4+Opt.CopyType].Selected=1;
          DialogItems[8].Selected=MenuCode;
          DialogItems[9].Selected=Opt.CopyAccess;
          DialogItems[10].Selected=Opt.CopyROSrc;
          DialogItems[11].Selected=Opt.CopyRODest;
          DialogItems[12].Selected=Opt.CopyAbort;
          struct CopyDialogData dialog_data;
          dialog_data.SrcRO=Opt.CopyROSrc;
          dialog_data.DstRO=Opt.CopyRODest;
          if(PInfo.SelectedItemsNumber>1)
          {
            sprintf(dialog_data.CopyMessage,GetMsg(mCpyDlgCopyToN+NumberType(PInfo.SelectedItemsNumber)),PInfo.SelectedItemsNumber);
            sprintf(dialog_data.MoveMessage,GetMsg(mCpyDlgMoveToN+NumberType(PInfo.SelectedItemsNumber)),PInfo.SelectedItemsNumber);
          }
          else
          {
            NormalizeName(InitDlg[0].X2-InitDlg[0].X1-3,mCpyDlgCopyTo1,PInfo.SelectedItems[0].FindData.cFileName,dialog_data.CopyMessage);
            NormalizeName(InitDlg[0].X2-InitDlg[0].X1-3,mCpyDlgMoveTo1,PInfo.SelectedItems[0].FindData.cFileName,dialog_data.MoveMessage);
          }
          strcpy(DialogItems[1].Data,dialog_data.CopyMessage);
          strcpy(DialogItems[2].Data,DestA);
          int DlgCode=Info.DialogEx(Info.ModuleNumber,-1,-1,76,19,"Copy",DialogItems,(sizeof(InitDlg)/sizeof(InitDlg[0])),0,0,CopyDialogProc,(DWORD)&dialog_data);
          if(DlgCode==14)
          {
            if(PlgOpt.ExpandVars)
            {
              char exp[MAX_PATH]; DWORD res;
              res=FSF.ExpandEnvironmentStr(DialogItems[2].Data,exp,sizeof(exp));
              strcpy(DialogItems[2].Data,exp);
            }
            char *filename;
            filename=strrchr(DialogItems[2].Data,'\\');
            if(!filename)
              filename=DialogItems[2].Data;
            if(!(strcmp(filename,".")&&strcmp(filename,"..")))
              strcat(DialogItems[2].Data,"\\");
            if(!GetFullPathName(DialogItems[2].Data,sizeof(DestA),DestA,&filename))
            {
              char err3[512];
              sprintf(err3,GetMsg(mCpyErr3),DialogItems[2].Data);
              const char *MsgItems[]={GetMsg(mError),err3,GetMsg(mOk)};
              Info.Message(Info.ModuleNumber,FMSG_ERRORTYPE|FMSG_WARNING,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),1);
              break;
            }
            UNCPath(DestA);
            //check for such names as \\ZG\TEMP
            if(!CheckSystemFile(DestA))
            {
              char Volume[MAX_PATH];
              FSF.GetPathRoot(DestA,Volume);
              if(strlen(DestA)<strlen(Volume))
                FSF.AddEndSlash(DestA);
            }
            if(DestA[strlen(DestA)-1]!='\\')
            {
              WIN32_FIND_DATAA find;
              HANDLE test_handle;
              if((test_handle=FindFirstFileA(DestA,&find))!=INVALID_HANDLE_VALUE)
              {
                FindClose(test_handle);
                if(find.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)
                  strcat(DestA,"\\");
              }
              else if((!CheckSystemFile(DestA))&&(PInfo.SelectedItemsNumber==1)&&(!(PInfo.SelectedItems[0].Flags&PPIF_SELECTED))&&(PInfo.SelectedItems[0].FindData.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY))
              {
                bcopy_flags[BCOPY_REN_COPY]=true;
                strcat(DestA,"\\");
              }
            }
            MultiByteToWideChar(CP_OEMCP,0,DestA,-1,DestW,MAX_PATH);
            if(CheckPaths(SrcW,DestW,FALSE))
              goto copyexit_err1;
            send[0]=OPERATION_COPY;
            /*fill flags*/
            send[1]=0;
            if(DialogItems[4].Selected)
              send[1]|=COPYFLAG_OVERWRITE;
            if(DialogItems[5].Selected)
              send[1]|=COPYFLAG_APPEND;
            if(DialogItems[6].Selected)
              send[1]|=COPYFLAG_SKIP;
            if(DialogItems[7].Selected)
              send[1]|=COPYFLAG_REFRESH;
            if(DialogItems[8].Selected)
            {
              send[1]|=COPYFLAG_MOVE;
              bcopy_flags[BCOPY_MOVE]=true;
              //check same drive
              char VolumeSrc[MAX_PATH],VolumeDest[MAX_PATH];
              FSF.GetPathRoot(SrcA,VolumeSrc);
              FSF.GetPathRoot(DestA,VolumeDest);
              if(!_stricmp(VolumeSrc,VolumeDest))
                bcopy_flags[BCOPY_NOREAL_COPY]=true;
            }
            if(DialogItems[9].Selected)
              send[1]|=COPYFLAG_ACCESS;
            if(DialogItems[10].Selected)
              send[1]|=COPYFLAG_ROSRC;
            if(DialogItems[11].Selected)
              send[1]|=COPYFLAG_RODST;
            if(DialogItems[12].Selected)
              send[1]|=COPYFLAG_FAIL;
            if(Opt.CopyFullInfo&&(!bcopy_flags[BCOPY_NOREAL_COPY]))
              send[1]|=COPYFLAG_STATISTIC;
            if(GetClearReadOnly())
            { // clear read-only attribute, when copying from CD
              char Volume[MAX_PATH],VolumeName[MAX_PATH],VolumeFS[MAX_PATH];
              DWORD VolumeSerialNumber,MaximumComponentLength,FileSystemFlags;
              FSF.GetPathRoot(SrcA,Volume);
              strcpy(VolumeFS,"    ");
              GetVolumeInformation(Volume,VolumeName,sizeof(VolumeName),&VolumeSerialNumber,&MaximumComponentLength,&FileSystemFlags,VolumeFS,sizeof(VolumeFS));
              if((GetDriveType(Volume)==DRIVE_CDROM)||(!_stricmp(VolumeFS,"CDFS")))
              {
                send[1]|=COPYFLAG_ATTR;
                send[1]|=COPYFLAG_CLEAR_READONLY;
              }
            }
            send[2]=PInfo.SelectedItemsNumber+2;
            //create destination dirs
            {
              if(bcopy_flags[BCOPY_REN_COPY]&&bcopy_flags[BCOPY_NOREAL_COPY]&&bcopy_flags[BCOPY_MOVE])
              { //don't create renamed dir
                int last_char_index=strlen(DestA)-1;
                if(DestA[last_char_index]=='\\')
                  DestA[last_char_index]=0;
              }
              char DirA[MAX_PATH],*DirEnd;
              if((strlen(DestA)>2)&&(!CheckSystemFile(DestA)))
              {
                BOOL CreateFlag=FALSE; char CreateDest[MAX_PATH];
                DirEnd=DestA+3;
                do
                {
                  DirEnd=strchr(DirEnd,'\\');
                  if(DirEnd)
                  {
                    strncpy(DirA,DestA,DirEnd-DestA); DirA[DirEnd-DestA]=0;
                    DirEnd++;
                    CreateDirectoryA(DirA,NULL);
                    CreateFlag=TRUE;
                  }
                } while(DirEnd);
                if(CreateFlag)
                {
                  strcpy(CreateDest,DirA);
                  strcat(CreateDest,"\\*");
                  WIN32_FIND_DATAA find;
                  SetLastError(0);
                  HANDLE hFind=FindFirstFileA(CreateDest,&find);
                  DWORD err=GetLastError();
                  if(hFind!=INVALID_HANDLE_VALUE)
                    FindClose(hFind);
                  if(err==ERROR_PATH_NOT_FOUND)
                  {
                    char err2[512];
                    sprintf(err2,GetMsg(mCpyErr2),DirA);
                    const char *MsgItems[]={GetMsg(mError),err2,GetMsg(mOk)};
                    Info.Message(Info.ModuleNumber,FMSG_WARNING,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),1);
                    goto copyexit;
                  }
                }
              }
            }
            #define CHECK_DEST if(CheckPaths(TestSrcW,DestW,TRUE)) goto copyexit_err1;
            #define DEST_W DestW
            #define ON_ERROR goto copyexit;
            #include "bcopy_find.cpp"
          }
          break;
copyexit_err1:
          {
            const char *MsgItems[]={GetMsg(mError),GetMsg(mCpyErr1),GetMsg(mOk)};
            Info.Message(Info.ModuleNumber,FMSG_WARNING,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),1);
          }
copyexit:
          break;
        }
        case 2:
        {
          if(!send) break;
          if(!CheckPipeEx()) break;
          //Show dialog
          /*
            000000000011111111112222222222333333333344444444445555555555666666
            012345678901234567890123456789012345678901234567890123456789012345
          00                                                                  00
          01    Copy    01
          02    Copy "bcopy.cpp" to                                         02
          03   Ķ   03
          04    [ ] Clear R/O attribute                                     04
          05    [ ] Abort on error                                          05
          06   Ķ   06
          07    [ Delete ] [ Cancel ]                                       07
          08   ͼ   08
          09                                                                  09
            000000000011111111112222222222333333333344444444445555555555666666
            012345678901234567890123456789012345678901234567890123456789012345
          */
          static struct InitDialogItem InitDlg[]={
          /* 0*/  {DI_DOUBLEBOX,3,1,62,8,0,0,0,0,(char *)mDelDlgTitle},
          /* 1*/  {DI_TEXT,5,2,0,0,0,0,DIF_SHOWAMPERSAND,0,""},
          /* 2*/  {DI_TEXT,5,3,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0,""},
          /* 3*/  {DI_CHECKBOX,5,4,0,0,0,0,0,0,(char *)mDelDlgChk1},
          /* 4*/  {DI_CHECKBOX,5,5,0,0,0,0,0,0,(char *)mDelDlgChk2},
          /* 5*/  {DI_TEXT,5,6,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0,""},
          /* 6*/  {DI_BUTTON,0,7,0,0,1,0,DIF_CENTERGROUP,1,(char *)mDelDlgOk},
          /* 7*/  {DI_BUTTON,0,7,0,0,0,0,DIF_CENTERGROUP,0,(char *)mDelDlgCancel}
          };
          struct FarDialogItem DialogItems[sizeof(InitDlg)/sizeof(InitDlg[0])];
          InitDialogItems(InitDlg,DialogItems,sizeof(InitDlg)/sizeof(InitDlg[0]));
          DialogItems[3].Selected=Opt.DeleteRO;
          DialogItems[4].Selected=Opt.DeleteAbort;
          if(PInfo.SelectedItemsNumber>1)
            sprintf(DialogItems[1].Data,GetMsg(mDelDlgDeleteN+NumberType(PInfo.SelectedItemsNumber)),PInfo.SelectedItemsNumber);
          else
            NormalizeName(InitDlg[0].X2-InitDlg[0].X1-3,mDelDlgDelete1,PInfo.SelectedItems[0].FindData.cFileName,DialogItems[1].Data);
          int DlgCode=Info.DialogEx(Info.ModuleNumber,-1,-1,66,10,"Delete",DialogItems,(sizeof(InitDlg)/sizeof(InitDlg[0])),0,0,DelDialogProc,0);
          if(DlgCode==6)
          {
            send[0]=OPERATION_COPY;
            /*fill flags*/
            send[1]=COPYFLAG_DELETE|COPYFLAG_OVERWRITE;
            if(DialogItems[3].Selected)
              send[1]|=COPYFLAG_ROSRC;
            if(DialogItems[4].Selected)
              send[1]|=COPYFLAG_FAIL;
            if(Opt.CopyFullInfo) //!!!
              send[1]|=COPYFLAG_STATISTIC;
            send[2]=PInfo.SelectedItemsNumber+2;
            #define CHECK_DEST
            #define DEST_W L""
            #define ON_ERROR ;
            #include "bcopy_find.cpp"
          }
          break;
        }
        case 3:
        {
          if(!send) break;
          if(!CheckPipeEx()) break;
          //Show dialog
          /*
            000000000011111111112222222222333333333344444
            012345678901234567890123456789012345678901234
          00                                             00
          01    Attributes ͻ   01
          02        Change file attributes for         02
          03              file_id_diz.m4               03
          04   Ķ   04
          05    [ ] Read only                          05
          06    [x] Archive                            06
          07    [ ] Hidden                             07
          08    [ ] System                             08
          09    [ ] Compressed                         09
          10   Ķ   10
          11            [ Set ]  [ Cancel ]            11
          12   ͼ   12
          13                                             13
            000000000011111111112222222222333333333344444
            012345678901234567890123456789012345678901234
          */
          static struct InitDialogItem InitDlg[]={
          /* 0*/  {DI_DOUBLEBOX,3,1,41,12,0,0,0,0,(char *)mAttrDlgTitle},
          /* 1*/  {DI_TEXT,0,3,0,0,0,0,DIF_SHOWAMPERSAND,0,""},
          /* 2*/  {DI_TEXT,0,2,0,0,0,0,0,0,(char *)mAttrDlgTitle2},
          /* 3*/  {DI_TEXT,5,4,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0,""},
          /* 4*/  {DI_CHECKBOX,5,5,0,0,1,2,DIF_3STATE,0,(char *)mAttrDlgReadOnly},
          /* 5*/  {DI_CHECKBOX,5,6,0,0,0,2,DIF_3STATE,0,(char *)mAttrDlgArchive},
          /* 6*/  {DI_CHECKBOX,5,7,0,0,0,2,DIF_3STATE,0,(char *)mAttrDlgHidden},
          /* 7*/  {DI_CHECKBOX,5,8,0,0,0,2,DIF_3STATE,0,(char *)mAttrDlgSystem},
          /* 8*/  {DI_CHECKBOX,5,9,0,0,0,2,DIF_3STATE|DIF_DISABLE,0,(char *)mAttrDlgCompressed},
          /* 9*/  {DI_TEXT,5,10,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0,""},
          /*10*/  {DI_BUTTON,0,11,0,0,1,0,DIF_CENTERGROUP,1,(char *)mAttrDlgSet},
          /*11*/  {DI_BUTTON,0,11,0,0,0,0,DIF_CENTERGROUP,0,(char *)mAttrDlgCancel}
          };
          struct FarDialogItem DialogItems[sizeof(InitDlg)/sizeof(InitDlg[0])];
          InitDialogItems(InitDlg,DialogItems,sizeof(InitDlg)/sizeof(InitDlg[0]));
          if(PInfo.SelectedItemsNumber>1)
            sprintf(DialogItems[1].Data,GetMsg(mAttrDlgChangeN+NumberType(PInfo.SelectedItemsNumber)),PInfo.SelectedItemsNumber);
          else
            NormalizeName(InitDlg[0].X2-InitDlg[0].X1-3,mAttrDlgChange1,PInfo.SelectedItems[0].FindData.cFileName,DialogItems[1].Data);
          DialogItems[1].X1=4+(37-strlen(DialogItems[1].Data))/2;
          DialogItems[2].X1=4+(37-strlen(DialogItems[2].Data))/2;
          { // clear read-only attribute, when copying from CD
            char Volume[MAX_PATH],VolumeName[MAX_PATH],VolumeFS[MAX_PATH];
            DWORD VolumeSerialNumber,MaximumComponentLength,FileSystemFlags;
            FSF.GetPathRoot(SrcA,Volume);
            if(GetVolumeInformation(Volume,VolumeName,sizeof(VolumeName),&VolumeSerialNumber,&MaximumComponentLength,&FileSystemFlags,VolumeFS,sizeof(VolumeFS)))
              if(FileSystemFlags&FS_FILE_COMPRESSION)
                DialogItems[8].Flags&=~DIF_DISABLE;
          }
          int DlgCode=Info.DialogEx(Info.ModuleNumber,-1,-1,45,14,"Attributes",DialogItems,(sizeof(InitDlg)/sizeof(InitDlg[0])),0,0,AttrDialogProc,0);
          if(DlgCode==10)
          {
            send[0]=OPERATION_COPY;
            /*fill flags*/
            send[1]=COPYFLAG_ATTRMAIN|COPYFLAG_ATTR|COPYFLAG_OVERWRITE;
            unsigned int flags[5][3]=
            {
              {COPYFLAG_CLEAR_READONLY,COPYFLAG_SET_READONLY,0},
              {COPYFLAG_CLEAR_ARCHIVE,COPYFLAG_SET_ARCHIVE,0},
              {COPYFLAG_CLEAR_HIDDEN,COPYFLAG_SET_HIDDEN,0},
              {COPYFLAG_CLEAR_SYSTEM,COPYFLAG_SET_SYSTEM,0},
              {COPYFLAG_CLEAR_COMPRESSED,COPYFLAG_SET_COMPRESSED,0},
            };
            for(int i=0;i<5;i++)
              send[1]|=flags[i][DialogItems[4+i].Selected];
            if(send[1]!=(COPYFLAG_ATTRMAIN|COPYFLAG_ATTR|COPYFLAG_OVERWRITE))
            {
              if(Opt.CopyFullInfo) //!!!
                send[1]|=COPYFLAG_STATISTIC;
              send[2]=PInfo.SelectedItemsNumber+2;
              #define CHECK_DEST
              #define DEST_W L""
              #define ON_ERROR ;
              #include "bcopy_find.cpp"
            }
          }
          break;
        }
        case 4:
        {
          if(!send) break;
          if(!CheckPipeEx()) break;
          //Show dialog
          /*
            000000000011111111112222222222333333333344444444445555555555666666
            012345678901234567890123456789012345678901234567890123456789012345
          00                                                                  00
          01    Wipe    01
          02    Wipe "bcopy.cpp"                                            02
          03   Ķ   03
          04    [ ] Abort on wipe error                                     04
          05   Ķ   05
          06    [ Wipe ] [ Cancel ]                                         06
          07   ͼ   07
          08                                                                  08
            000000000011111111112222222222333333333344444444445555555555666666
            012345678901234567890123456789012345678901234567890123456789012345
          */
          static struct InitDialogItem InitDlg[]={
          /* 0*/  {DI_DOUBLEBOX,3,1,62,7,0,0,0,0,(char *)mWpeDlgTitle},
          /* 1*/  {DI_TEXT,5,2,0,0,0,0,DIF_SHOWAMPERSAND,0,""},
          /* 2*/  {DI_TEXT,5,3,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0,""},
          /* 3*/  {DI_CHECKBOX,5,4,0,0,0,0,0,0,(char *)mWpeDlgChk},
          /* 4*/  {DI_TEXT,5,5,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0,""},
          /* 5*/  {DI_BUTTON,0,6,0,0,1,0,DIF_CENTERGROUP,1,(char *)mWpeDlgOk},
          /* 6*/  {DI_BUTTON,0,6,0,0,0,0,DIF_CENTERGROUP,0,(char *)mWpeDlgCancel}
          };
          struct FarDialogItem DialogItems[sizeof(InitDlg)/sizeof(InitDlg[0])];
          InitDialogItems(InitDlg,DialogItems,sizeof(InitDlg)/sizeof(InitDlg[0]));
//          DialogItems[3].Selected=Opt.WipeAbort;
          if(PInfo.SelectedItemsNumber>1)
            sprintf(DialogItems[1].Data,GetMsg(mWpeDlgWipeN+NumberType(PInfo.SelectedItemsNumber)),PInfo.SelectedItemsNumber);
          else
            NormalizeName(InitDlg[0].X2-InitDlg[0].X1-3,mWpeDlgWipe1,PInfo.SelectedItems[0].FindData.cFileName,DialogItems[1].Data);
          int DlgCode=Info.DialogEx(Info.ModuleNumber,-1,-1,66,9,"Delete",DialogItems,(sizeof(InitDlg)/sizeof(InitDlg[0])),0,0,WipeDialogProc,0);
          if(DlgCode==5)
          {
            send[0]=OPERATION_COPY;
            /*fill flags*/
            send[1]=COPYFLAG_DELETE|COPYFLAG_WIPE|COPYFLAG_OVERWRITE;
            if(DialogItems[3].Selected)
              send[1]|=COPYFLAG_FAIL;
            if(Opt.CopyFullInfo) //!!!
              send[1]|=COPYFLAG_STATISTIC;
            send[2]=PInfo.SelectedItemsNumber+2;
            #define CHECK_DEST
            #define DEST_W L""
            #define ON_ERROR ;
            #include "bcopy_find.cpp"
          }
          break;
        }
        case 6:
        case 7:
        {
          if((PInfo.CurrentItem >= 0) && !(PInfo.PanelItems[PInfo.CurrentItem].FindData.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY))
          {
            char SrcLA[MAX_PATH];
            char *ShortFileName=PInfo.PanelItems[PInfo.CurrentItem].FindData.cAlternateFileName;
            strcpy(SrcLA,SrcA);
            if(!ShortFileName[0])
              ShortFileName=PInfo.PanelItems[PInfo.CurrentItem].FindData.cFileName;
            strcat(SrcA,ShortFileName);
            strcat(SrcLA,PInfo.PanelItems[PInfo.CurrentItem].FindData.cFileName);
            if(MenuCode==6)
              Info.Viewer(SrcA,SrcLA,0,0,-1,-1,VF_NONMODAL);
            else
              Info.Editor(SrcA,SrcLA,0,0,-1,-1,EF_NONMODAL,1,1);
          }
          break;
        }
      }
      free(send);
    }
  }
  else
  {
    switch(MenuCode)
    {
      case 9:
      case 10:
      {
        ShowDiskMenu(MenuCode-9);
        break;
      }
      case 11:
        RefreshSCSI();
        break;
      case 13:
        Configure(0);
        break;
      case 14:
      {
        ShowInfoMenu();
        break;
      }
    }
  }
  return(INVALID_HANDLE_VALUE);
}

int WINAPI _export Configure(int ItemNumber)
{
  switch(ItemNumber)
  {
    case 0:
      return(Config());
  }
  return(FALSE);
}

#ifdef __cplusplus
extern "C"{
#endif
  BOOL WINAPI DllMainCRTStartup(HANDLE hDll,DWORD dwReason,LPVOID lpReserved);
#ifdef __cplusplus
};
#endif

BOOL WINAPI DllMainCRTStartup(HANDLE hDll,DWORD dwReason,LPVOID lpReserved)
{
  return TRUE;
}
