#include <winioctl.h>

static void DiskEject(char ADisk,BOOL type)
{
  HANDLE DiskHandle;
  BOOL Retry=TRUE,Ignore=FALSE;
  DWORD temp;
  DWORD AccessFlags=GENERIC_READ|GENERIC_WRITE;
  char DiskPath[7]="\\\\.\\ :",DrivePath[4]=" :\\";
  DiskPath[4]=ADisk;
  DrivePath[0]=ADisk;
  if(GetDriveType(DrivePath)==DRIVE_CDROM) AccessFlags=GENERIC_READ;
  DiskHandle=CreateFile(DiskPath,AccessFlags,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,0,0);
  if(DiskHandle!=INVALID_HANDLE_VALUE)
  {
    while(Retry)
      if(PlgOpt.ForceEject||Ignore||(DeviceIoControl(DiskHandle,FSCTL_LOCK_VOLUME,NULL,0,NULL,0,&temp,NULL)&&DeviceIoControl(DiskHandle,FSCTL_DISMOUNT_VOLUME,NULL,0,NULL,0,&temp,NULL)))
      {
        PREVENT_MEDIA_REMOVAL PreventMediaRemoval;
        PreventMediaRemoval.PreventMediaRemoval=FALSE;
        if(DeviceIoControl(DiskHandle,IOCTL_STORAGE_MEDIA_REMOVAL,&PreventMediaRemoval,sizeof(PreventMediaRemoval),NULL,0,&temp,NULL))
        {
          if(!type)
            DeviceIoControl(DiskHandle,IOCTL_STORAGE_EJECT_MEDIA,NULL,0,NULL,0,&temp,NULL);
          else
            DeviceIoControl(DiskHandle,IOCTL_STORAGE_LOAD_MEDIA,NULL,0,NULL,0,&temp,NULL);
        }
        Retry=FALSE;
      }
      else
      {
        Ignore=FALSE;
        const char *MsgItems[]={GetMsg(mError),GetMsg(mEjectRetry),GetMsg(mEjectIgnore),GetMsg(mEjectCancel)};
        int MsgCode=Info.Message(Info.ModuleNumber,FMSG_ERRORTYPE|FMSG_WARNING,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),3);
        switch(MsgCode)
        {
          case 1:
            Ignore=TRUE;
            break;
          case -1:
          case 2:
            Retry=FALSE;
            break;
        }
      }
    DeviceIoControl(DiskHandle,FSCTL_UNLOCK_VOLUME,NULL,0,NULL,0,&temp,NULL);
    CloseHandle(DiskHandle);
  }
}

static void ShowDiskMenu(BOOL type)
{
  DWORD Disks;
  int DiskCount=0;
  struct FarMenuItem *DiskMenuItems=NULL;
  Disks=GetLogicalDrives();
  {
    char DrivePath[4]=" :\\";
    for(int i=0;i<27;i++)
      if(Disks&(1<<i))
      {
        DrivePath[0]=i+'A';
        unsigned int disk_type=GetDriveType(DrivePath);
        if((disk_type==DRIVE_REMOVABLE)||(disk_type==DRIVE_CDROM))
          DiskCount++;
        else
          Disks&=~(1<<i);
      }
  }
  if(DiskCount)
  {
    DiskMenuItems=(struct FarMenuItem *)malloc(DiskCount*sizeof(struct FarMenuItem));
    if(DiskMenuItems)
    {
      for(int i=0,j=0;i<27;i++)
        if(Disks&(1<<i))
        {
          DiskMenuItems[j].Text[0]='&';
          DiskMenuItems[j].Text[1]='A'+i;
          DiskMenuItems[j].Text[2]=':';
          j++;
        }
      DiskMenuItems[0].Selected=TRUE;
    }
    int i=Info.Menu(Info.ModuleNumber,-1,-1,0,FMENU_WRAPMODE,type?GetMsg(mEjectLoad):GetMsg(mEjectEject),NULL,"Contents",NULL,NULL,DiskMenuItems,DiskCount);
    if(i>-1)
      DiskEject(DiskMenuItems[i].Text[1],type);
    free(DiskMenuItems);
  }
}

static void RefreshSCSI(void)
{
  char buff[20],Msg[256]; HANDLE hSCSI; DWORD ret; BOOL WaitMessage=FALSE;
  HANDLE hSScr=Info.SaveScreen(0,0,-1,-1);
  for(int i=0;i<10;i++)
  {
    sprintf(buff,"\\\\.\\Scsi%d:",i);
    sprintf(Msg,GetMsg(mSCSIRefresh),buff);
    const char *MsgItems[]={"",Msg};
    Info.Message(Info.ModuleNumber,WaitMessage?FMSG_KEEPBACKGROUND:0,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),0);
    WaitMessage=TRUE;
    hSCSI=CreateFile(buff,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,0,NULL);
    if(hSCSI!=INVALID_HANDLE_VALUE)
    {
      DeviceIoControl(hSCSI,0x4101c,NULL,0,NULL,0,&ret,NULL);
      CloseHandle(hSCSI);
    }
    else
      break;
  }
  Info.RestoreScreen(hSScr);
}
