#include <stdio.h>
#include "../../plugin.hpp"
#include "../../farkeys.hpp"
#include "../../farcolor.hpp"
#include "bcplugin.h"

enum
{
  getinfoSuccess,
  getinfoError,
  getinfoBusy,
};

static inline void normalize_2(WORD &value)
{
  if(value>99) value=0;
}

static inline void normalize_4(WORD &value)
{
  if(value>9999) value=0;
}

static long WINAPI InfoDialogProc(HANDLE hDlg,int Msg,int Param1,long Param2)
{
  DWORD *DlgParams=(DWORD *)Info.SendDlgMessage(hDlg,DM_GETDLGDATA,0,0);
  switch(Msg)
  {
    case DN_INITDIALOG:
      Info.SendDlgMessage(hDlg,DM_SETDLGDATA,0,Param2);
      break;
    case DN_BTNCLICK:
      if(Param1==3) SendCommand(DlgParams[0],INFOFLAG_PAUSE);
      break;
    case DN_KEY:
      if((Param2==KEY_ADD)||(Param2==KEY_SUBTRACT))
      {
        if(Param2==KEY_ADD)
          DlgParams[1]=!DlgParams[1];
        else
          DlgParams[2]=!DlgParams[2];
      }
      break;
    case DN_CTLCOLORDLGITEM:
      if(DlgParams[3]&&(Param1==(int)DlgParams[3])&&PlgOpt.ErrorColor)
        return PlgOpt.ErrorColor|(PlgOpt.ErrorColor<<8);
      break;
    case DN_ENTERIDLE:
      InfoRec receive;
      if(GetInfo(DlgParams[0],&receive)) break;
      if(receive.info.type>INFOTYPE_INVALID)
      {
        const unsigned int shifts[]={0,2,2,0,0,0};
        unsigned int shift=shifts[receive.info.type];
        char SrcA[MAX_PATH];
        FarDialogItemData Caption;
        if(receive.info.pause)
          Caption.PtrData=(char *)GetMsg(mInfoDlgContinue);
        else
          Caption.PtrData=(char *)GetMsg(mInfoDlgPause);
        Caption.PtrLength=strlen(Caption.PtrData);
        Info.SendDlgMessage(hDlg,DM_SETTEXT,3,(long)&Caption);
        WideCharToMultiByte(CP_OEMCP,0,receive.Src,-1,SrcA,MAX_PATH,NULL,NULL);
        Caption.PtrData=FSF.TruncPathStr(SrcA,66);
        Caption.PtrLength=strlen(Caption.PtrData);
        Info.SendDlgMessage(hDlg,DM_SETTEXT,5,(long)&Caption);
        if(receive.info.type<INFOTYPE_WIPE)
        {
          WideCharToMultiByte(CP_OEMCP,0,receive.Dest,-1,SrcA,MAX_PATH,NULL,NULL);
          Caption.PtrData=FSF.TruncPathStr(SrcA,66);
          Caption.PtrLength=strlen(Caption.PtrData);
          Info.SendDlgMessage(hDlg,DM_SETTEXT,8,(long)&Caption);
        }
        if((receive.info.InfoEx)&&(receive.TotalSize))
        {
          DlgParams[3]=(receive.Errors)?(10+shift):0;
          FILETIME start,current,finish; SYSTEMTIME CurrTime,FinishTime;
          unsigned long long llstart,llcurrent,llfinish; unsigned int percent;
          GetLocalTime(&CurrTime);
          SystemTimeToFileTime(&receive.StartTime,&start);
          SystemTimeToFileTime(&CurrTime,&current);
          memcpy(&llstart,&start,sizeof(llstart));
          memcpy(&llcurrent,&current,sizeof(llcurrent));
          llfinish=llstart;
          if((receive.CurrentSize+receive.CurrentSizeAdd)!=0LL)
          {
            double relation=receive.TotalSize;
            relation/=(receive.CurrentSize+receive.CurrentSizeAdd);
            llfinish+=(unsigned long long)(relation*(llcurrent-llstart-receive.PauseTime))+receive.PauseTime;
          }
          memcpy(&finish,&llfinish,sizeof(llfinish));
          FileTimeToSystemTime(&finish,&FinishTime);
          if(DlgParams[2]&&(!receive.SizeType))
          {
            unsigned long long cur_size=receive.CurrentSize+receive.CurrentSizeAdd,total_size=receive.TotalSize;
            int cur_unit=mUnits1,total_unit=mUnits1;
            while((cur_size>=10000)&&(cur_unit<=mUnits6))
            {
              cur_size/=1024;
              cur_unit++;
            }
            while((total_size>=10000)&&(total_unit<=mUnits6))
            {
              total_size/=1024;
              total_unit++;
            }
            sprintf(SrcA,GetMsg(mInfoDlgStatus1a),cur_size,GetMsg(cur_unit),total_size,GetMsg(total_unit));
          }
          else
            sprintf(SrcA,GetMsg(mInfoDlgStatus1),receive.CurrentSize+receive.CurrentSizeAdd,receive.TotalSize);
          Caption.PtrData=SrcA;
          Caption.PtrLength=strlen(Caption.PtrData);
          Info.SendDlgMessage(hDlg,DM_SETTEXT,8+shift,(long)&Caption);
          { //normalize finish time
            normalize_2(FinishTime.wDay);
            normalize_2(FinishTime.wMonth);
            normalize_4(FinishTime.wYear);
            normalize_2(FinishTime.wHour);
            normalize_2(FinishTime.wMinute);
            normalize_2(FinishTime.wSecond);
          }
          if(DlgParams[1])
            sprintf(SrcA,GetMsg(mInfoDlgStatus2a),CurrTime.wDay,CurrTime.wMonth,CurrTime.wYear,CurrTime.wHour,CurrTime.wMinute,CurrTime.wSecond,FinishTime.wDay,FinishTime.wMonth,FinishTime.wYear,FinishTime.wHour,FinishTime.wMinute,FinishTime.wSecond);
          else
            sprintf(SrcA,GetMsg(mInfoDlgStatus2),receive.StartTime.wDay,receive.StartTime.wMonth,receive.StartTime.wYear,receive.StartTime.wHour,receive.StartTime.wMinute,receive.StartTime.wSecond,FinishTime.wDay,FinishTime.wMonth,FinishTime.wYear,FinishTime.wHour,FinishTime.wMinute,FinishTime.wSecond);
          Caption.PtrData=SrcA;
          Caption.PtrLength=strlen(Caption.PtrData);
          Info.SendDlgMessage(hDlg,DM_SETTEXT,9+shift,(long)&Caption);
          double fCPS=((llcurrent-llstart-receive.PauseTime)/10000000.0);
          if(fCPS>0.0)
            fCPS=(receive.CurrentSize+receive.CurrentSizeAdd)/fCPS;
          else
            fCPS=0.0;
          unsigned long long CPS=(unsigned long long)fCPS;
          if(DlgParams[2]&&(!receive.SizeType))
          {
            unsigned long long cps_norm=CPS;
            int cps_unit=mUnits1;
            while((cps_norm>=10000)&&(cps_unit<=mUnits6))
            {
              cps_norm/=1024;
              cps_unit++;
            }
            sprintf(SrcA,GetMsg(mInfoDlgStatus3a),receive.Errors,cps_norm,GetMsg(cps_unit));
          }
          else
            sprintf(SrcA,GetMsg((receive.SizeType)?mInfoDlgStatus3b:mInfoDlgStatus3),receive.Errors,CPS);
          Caption.PtrData=SrcA;
          Caption.PtrLength=strlen(Caption.PtrData);
          Info.SendDlgMessage(hDlg,DM_SETTEXT,10+shift,(long)&Caption);

          char *Fill=(char *)GetMsg(mInfoDlgFill);
          char Gauge[62];
          percent=0;
          if(receive.TotalSize!=0LL)
            percent=(receive.CurrentSize+receive.CurrentSizeAdd)*61/receive.TotalSize;
          for(unsigned int i=0;i<percent;i++)
            Gauge[i]=Fill[0];
          for(unsigned int i=percent;i<61;i++)
            Gauge[i]=Fill[1];
          Gauge[61]=0;
          percent=0;
          if(receive.TotalSize!=0LL)
            percent=(receive.CurrentSize+receive.CurrentSizeAdd)*100/receive.TotalSize;
          if(percent>100) percent=100;
          sprintf(SrcA,GetMsg(mInfoDlgStatus4),percent,Gauge);
          Caption.PtrData=SrcA;
          Caption.PtrLength=strlen(Caption.PtrData);
          Info.SendDlgMessage(hDlg,DM_SETTEXT,11+shift,(long)&Caption);
        }
        else if(receive.info.InfoEx)
        {
          Caption.PtrData=(char *)GetMsg(mInfoDlgWait);
          Caption.PtrLength=strlen(Caption.PtrData);
          Info.SendDlgMessage(hDlg,DM_SETTEXT,8+shift,(long)&Caption);
        }
        //refresh
        Info.SendDlgMessage(hDlg,DM_SETREDRAW,0,0);
      }
      else
        Info.SendDlgMessage(hDlg,DM_CLOSE,1,0); //Ok button
      break;
  }
  return Info.DefDlgProc(hDlg,Msg,Param1,Param2);
}

void ShowInfoDialog(SmallInfoRec *receive)
{
  //Show dialog
  /*
    0000000000111111111122222222223333333333444444444455555555556666666666777777
    0123456789012345678901234567890123456789012345678901234567890123456789012345
  00                                                                            00
  01    Copy ͻ   01
  02    Copying the file                                                      02
  03    C:\Program Files\Adobe\Illustrator 9.0\Illustrator.exe                03
  04    to                                                                    04
  05    C:\TEMP\Illustrator 9.0\Illustrator.exe                               05
  06   Ķ   06
  07    Copied/Total:          19223372036854775807 / 19223372036854775807    07
  08    Start/Finish:           20.01.2001 12.01.03 /  20.01.2001 12.01.03    08
  09    Average CPS:                                  19223372036854775807    09
  10    100%     10
  11   Ķ   11
  12                    [ OK ]    [ Pause ]     [ Stop ]                      12
  13   ͼ   13
  14                                                                            14
    0000000000111111111122222222223333333333444444444455555555556666666666777777
    0123456789012345678901234567890123456789012345678901234567890123456789012345
  */
  struct FarDialogItem DialogItems[14];
  memset(DialogItems,0,sizeof(DialogItems));
  unsigned int i=0,height=8;
  const unsigned int height_add[]={0,2,2,0,0,0},last_row[]={0,11,11,9,9,9},info_add=5;
  height+=height_add[receive->type];
  if(receive->InfoEx)
    height+=info_add;
  //border
  DialogItems[i].Type=DI_DOUBLEBOX; DialogItems[i].X1=3; DialogItems[i].Y1=1;
  DialogItems[i].X2=72; DialogItems[i].Y2=height-2; i++;
  //Ok button
  DialogItems[i].Type=DI_BUTTON; DialogItems[i].Y1=height-3; DialogItems[i].Focus=1; DialogItems[i].DefaultButton=1;
  DialogItems[i].Flags=DIF_CENTERGROUP; strcpy(DialogItems[i].Data,GetMsg(mInfoDlgOk)); i++;
  //Stop button
  DialogItems[i].Type=DI_BUTTON; DialogItems[i].Y1=height-3;
  DialogItems[i].Flags=DIF_CENTERGROUP; strcpy(DialogItems[i].Data,GetMsg(mInfoDlgStop)); i++;
  //Continue button
  DialogItems[i].Type=DI_BUTTON; DialogItems[i].Y1=height-3;
  DialogItems[i].Flags=DIF_CENTERGROUP|DIF_BTNNOCLOSE; strcpy(DialogItems[i].Data,GetMsg(mInfoDlgPause)); i++;

  DialogItems[i].Type=DI_TEXT; DialogItems[i].X1=5; DialogItems[i].Y1=2;
  switch(receive->type)
  {
    case INFOTYPE_COPY:
      strcpy(DialogItems[i-4].Data,GetMsg(mCpyDlgCopyTitle));
      strcpy(DialogItems[i].Data,GetMsg(mInfoDlgCopy));
      break;
    case INFOTYPE_MOVE:
      strcpy(DialogItems[i-4].Data,GetMsg(mCpyDlgMoveTitle));
      strcpy(DialogItems[i].Data,GetMsg(mInfoDlgMove));
      break;
    case INFOTYPE_WIPE:
      strcpy(DialogItems[i-4].Data,GetMsg(mWpeDlgTitle));
      strcpy(DialogItems[i].Data,GetMsg(mInfoDlgWipe));
      break;
    case INFOTYPE_DELETE:
      strcpy(DialogItems[i-4].Data,GetMsg(mDelDlgTitle));
      strcpy(DialogItems[i].Data,GetMsg(mInfoDlgDelete));
      break;
    case INFOTYPE_ATTR:
      strcpy(DialogItems[i-4].Data,GetMsg(mAttrDlgTitle));
      strcpy(DialogItems[i].Data,GetMsg(mInfoDlgAttr));
      break;
  }
  i++;
  DialogItems[i].Type=DI_TEXT; DialogItems[i].X1=5; DialogItems[i].Y1=3;
  DialogItems[i].Flags=DIF_SHOWAMPERSAND; i++;
  DialogItems[i].Type=DI_TEXT; DialogItems[i].Y1=height-4;
  DialogItems[i].Flags=DIF_BOXCOLOR|DIF_SEPARATOR; i++;

  unsigned int j=4; //i=6
  if(receive->type<INFOTYPE_WIPE)
  {
    DialogItems[i].Type=DI_TEXT; DialogItems[i].X1=5; DialogItems[i].Y1=j;
    strcpy(DialogItems[i].Data,GetMsg(mInfoDlgTo)); i++; j++;
    DialogItems[i].Type=DI_TEXT; DialogItems[i].X1=5; DialogItems[i].Y1=j;
    DialogItems[i].Flags=DIF_SHOWAMPERSAND; i++; j++;
  }
  if(receive->InfoEx) //i=8 or 6
  {
    DialogItems[i].Flags=DIF_BOXCOLOR|DIF_SEPARATOR;
    for(;j<last_row[receive->type];i++,j++)
    {
      DialogItems[i].Type=DI_TEXT; DialogItems[i].X1=5; DialogItems[i].Y1=j;
    }
  }
  DWORD DlgParams[4]={receive->ThreadId,PlgOpt.CurrentTime,PlgOpt.FormatSize,0};
  int DlgCode=Info.DialogEx(Info.ModuleNumber,-1,-1,76,height,"Info",DialogItems,i,0,0,InfoDialogProc,(DWORD)DlgParams);
  PlgOpt.CurrentTime=DlgParams[1]; PlgOpt.FormatSize=DlgParams[2];
  if((DlgCode==2)||(DlgCode==-1)) AbortThread(receive->ThreadId);
  if(PlgOpt.AutoRefresh)
  {
    char left[MAX_PATH],right[MAX_PATH],from[MAX_PATH],to[MAX_PATH];
    char *panels[]={left,right};
    int get[]={FCTL_GETPANELINFO,FCTL_GETANOTHERPANELINFO};
    int update[]={FCTL_UPDATEPANEL,FCTL_UPDATEANOTHERPANEL};
    int redraw[]={FCTL_REDRAWPANEL,FCTL_REDRAWANOTHERPANEL};
    PanelInfo PInfo;
    for(unsigned int i=0;i<sizeof(panels)/sizeof(panels[0]);i++)
    {
      Info.Control(INVALID_HANDLE_VALUE,get[i],&PInfo);
      strcpy(panels[i],"|");
      if(PInfo.PanelType==PTYPE_FILEPANEL)
      {
        strcpy(panels[i],PInfo.CurDir);
        UNCPath(panels[i]);
        FSF.AddEndSlash(panels[i]);
      }
    }
    WideCharToMultiByte(CP_OEMCP,0,receive->SrcDir,-1,from,sizeof(from)/sizeof(from[0]),NULL,NULL);
    WideCharToMultiByte(CP_OEMCP,0,receive->DestDir,-1,to,sizeof(to)/sizeof(to[0]),NULL,NULL);
    if(receive->type>INFOTYPE_MOVE) strcpy(to,"*");
    if(receive->type==INFOTYPE_COPY||receive->type==INFOTYPE_ATTR) strcpy(from,"*");
    for(unsigned int i=0;i<sizeof(panels)/sizeof(panels[0]);i++)
    {
      if(!_stricmp(panels[i],from)||!_stricmp(panels[i],to))
      {
        Info.Control(INVALID_HANDLE_VALUE,update[i],(void *)1);
        Info.Control(INVALID_HANDLE_VALUE,redraw[i],NULL);
      }
    }
  }
}

void SendCommand(DWORD ThreadId,DWORD Command)
{
  DWORD send[3]={OPERATION_INFO,Command,ThreadId};
  DWORD Transfered;
  HANDLE hPipe=CreateFile(PIPE_NAME,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
  if(hPipe!=INVALID_HANDLE_VALUE)
  {
    WriteFile(hPipe,send,sizeof(send),&Transfered,NULL);
    CloseHandle(hPipe);
  }
}

bool GetInfo(DWORD ThreadId,InfoRec *receive)
{
  bool res=false;
  DWORD dwBytesRead,dwBytesWritten;
  DWORD send[3]={OPERATION_INFO,INFOFLAG_BYHANDLE};
  send[2]=ThreadId;
  receive->info.type=INFOTYPE_INVALID;
  HANDLE hPipe=CreateFile(PIPE_NAME,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
  if(hPipe!=INVALID_HANDLE_VALUE)
  {
    WriteFile(hPipe,send,sizeof(send),&dwBytesWritten,NULL);
    ReadFile(hPipe,receive,sizeof(InfoRec),&dwBytesRead,NULL);
    CloseHandle(hPipe);
  }
  else if(GetLastError()==ERROR_PIPE_BUSY) res=true;
  return res;
}

void AbortThread(DWORD ThreadId)
{
  bool process=true;
  if(PlgOpt.ConfirmAbort)
  {
    InfoRec receive_big;
    bool busy=GetInfo(ThreadId,&receive_big);
    if((receive_big.info.type>INFOTYPE_INVALID)||(busy))
    {
      BOOL pause_old=receive_big.info.pause;
      if((!busy)&&(!pause_old)) SendCommand(ThreadId,INFOFLAG_PAUSE);
      const char *MsgItems[]={GetMsg(mName),GetMsg(mAbortText),GetMsg(mInfoDlgStop),GetMsg(mInfoDlgContinue)};
      if(Info.Message(Info.ModuleNumber,FMSG_WARNING,"Abort",MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),2)) process=false;
      if((!busy)&&(!pause_old))
      {
        GetInfo(ThreadId,&receive_big);
        if((receive_big.info.type>INFOTYPE_INVALID)&&(receive_big.info.pause))
          SendCommand(ThreadId,INFOFLAG_PAUSE);
      }
    }
  }
  if(process) SendCommand(ThreadId,INFOFLAG_STOP);
}
