#include "bcCommon.h"

enum {
  mName,
  //main menu items
  mMenuCopy,
  mMenuMove,
  mMenuDelete,
  mMenuAttr,
  mMenuWipe,
  mMenuSep1,
  mMenuView,
  mMenuEdit,
  mMenuSep2,
  mMenuEject,
  mMenuReject,
  mMenuRefreshSCSI,
  mMenuSep3,
  mMenuConfig,
  mMenuInfo,
  //copy dialog
  mCpyDlgCopyTitle,
  mCpyDlgMoveTitle,
  mCpyDlgOkCopy,
  mCpyDlgOkMove,
  mCpyDlgCancel,
  mCpyDlgCopyTo1,
  mCpyDlgCopyTox1,
  mCpyDlgCopyTo234,
  mCpyDlgCopyToN,
  mCpyDlgMoveTo1,
  mCpyDlgMoveTox1,
  mCpyDlgMoveTo234,
  mCpyDlgMoveToN,
  mCpyDlgOpt1,
  mCpyDlgOpt2,
  mCpyDlgOpt3,
  mCpyDlgOpt4,
  mCpyDlgChk1,
  mCpyDlgChk2,
  mCpyDlgChk3,
  mCpyDlgChk4,
  mCpyDlgChkAccess,
  //delete dialog
  mDelDlgTitle,
  mDelDlgOk,
  mDelDlgCancel,
  mDelDlgDelete1,
  mDelDlgDeletex1,
  mDelDlgDelete234,
  mDelDlgDeleteN,
  mDelDlgChk1,
  mDelDlgChk2,
  //wipe dialog
  mWpeDlgTitle,
  mWpeDlgOk,
  mWpeDlgCancel,
  mWpeDlgWipe1,
  mWpeDlgWipex1,
  mWpeDlgWipe234,
  mWpeDlgWipeN,
  mWpeDlgChk,
  //attributes dialog
  mAttrDlgTitle,
  mAttrDlgTitle2,
  mAttrDlgChange1,
  mAttrDlgChangex1,
  mAttrDlgChange234,
  mAttrDlgChangeN,
  mAttrDlgReadOnly,
  mAttrDlgArchive,
  mAttrDlgHidden,
  mAttrDlgSystem,
  mAttrDlgCompressed,
  mAttrDlgSet,
  mAttrDlgCancel,
  //eject
  mEjectEject,
  mEjectLoad,
  mEjectRetry,
  mEjectIgnore,
  mEjectCancel,
  //info
  mInfoCopy,
  mInfoMove,
  mInfoWipe,
  mInfoDel,
  mInfoAttr,
  mInfoSep,
  mInfoBottom,
  mInfoDlgOk,
  mInfoDlgStop,
  mInfoDlgPause,
  mInfoDlgContinue,

  mInfoDlgCopy,
  mInfoDlgMove,
  mInfoDlgWipe,
  mInfoDlgDelete,
  mInfoDlgAttr,
  mInfoDlgTo,
  mInfoDlgStatus1,
  mInfoDlgStatus1a,
  mInfoDlgStatus2,
  mInfoDlgStatus2a,
  mInfoDlgStatus3,
  mInfoDlgStatus3a,
  mInfoDlgStatus3b,
  mInfoDlgStatus4,
  mInfoDlgFill,
  mInfoDlgWait,
  //config
  mConfigMenu1,
  mConfigMenu2,
  mConfigMenu3,
  mConfigSave,
  mConfigCancel,
  mConfigHistory,
  mConfigFullInfo,
  mConfigDelAbort,
  mConfigAutostart,
  mConfigConfigMenu,
  mConfigViewerMenu,
  mConfigEditorMenu,
  mConfigInfo,
  mConfigInfoEmpty,
  mConfigInfoOnly,
  mComfigAutoShowInfo,
  mConfigExpandVars,
  mConfigPassive,
  mConfigFormatSize,
  mConfigConfirmAbort,
  mConfigCurrentTime,
  mConfigAutoRefresh,
  mConfigMaxErrors,
  mConfigThreadCount,
  mConfigAllowNetwork,
  mConfigSetPassword,
  mConfigClearPassword,
  //color
  mColorMain,
  mColorForeground,
  mColorBackground,
  mColorTest1,
  mColorTest2,
  mColorTest3,
  mColorSet,
  mColorCancel,
  //units
  mUnits1,
  mUnits2,
  mUnits3,
  mUnits4,
  mUnits5,
  mUnits6,
  //pwd
  mPwdTitle,
  mPwdSet,
  mPwdCancel,
  mPwdCleared,
  mPwdSeted,
  //errors
  mError,
  mCpyErr1,
  mCpyErr2,
  mCpyErr3,
  mErrorNoPipe,
  mNoWork,
  mActualize,
  mAbortText,
  //scsi
  mSCSIRefresh,
  //common buttons
  mOk,
  mYes,
  mNo,
};

#define FAR165_INFO_SIZE 336

#define FAR_SYSTEM_KEY "Software\\Far\\System"
#define FAR_READONLY_CD "ClearReadOnly"

struct CopyDialogData
{
  char CopyMessage[512];
  char MoveMessage[512];
  BOOL SrcRO;
  BOOL DstRO;
};

struct InitDialogItem
{
  int Type;
  int X1,Y1,X2,Y2;
  int Focus;
  int Selected;
  unsigned int Flags;
  int DefaultButton;
  char *Data;
};

struct Options
{
  int  CopyType;
  BOOL CopyHistory;
  BOOL CopyROSrc;
  BOOL CopyRODest;
  BOOL CopyAbort;
  BOOL CopyFullInfo;
  BOOL CopyAccess;
  BOOL DeleteRO;
  BOOL DeleteAbort;
};

struct PlugOptions
{
  DWORD AutoStart;
  DWORD ShowMenu;
  DWORD InfoMenu;
  DWORD ExpandVars;
  BOOL CheckPassive;
  BOOL FormatSize;
  BOOL AutoShowInfo;
  BOOL ConfirmAbort;
  BOOL CurrentTime;
  BOOL AutoRefresh;
  BOOL ForceEject;
  DWORD ErrorColor;
};

extern Options Opt;
extern PlugOptions PlgOpt;

extern PluginStartupInfo Info;
extern FARSTANDARDFUNCTIONS FSF;

extern void InitDialogItems(InitDialogItem *Init,FarDialogItem *Item,int ItemsNumber);
extern const char *GetMsg(int MsgId);
extern void UNCPath(char *path);

extern void ShowInfoDialog(SmallInfoRec *receive);
extern void SendCommand(DWORD ThreadId,DWORD Command);
extern bool GetInfo(DWORD ThreadId,InfoRec *receive);
extern void AbortThread(DWORD ThreadId);
extern void ShowInfoMenu(void);
extern bool SelectColor(int *fg,int *bg);

#define BCOPY_REN_COPY    0
#define BCOPY_NOREAL_COPY 1
#define BCOPY_MOVE        2
#define BCOPY_FLAG_COUNT  3

#define SHOW_IN_VIEWER 1
#define SHOW_IN_EDITOR 2
#define SHOW_IN_CONFIG 4

#define INFO_MENU_ALT_0 1
#define INFO_MENU_ALT_1 2
